diff -NurpP --minimal linux-3.0.23/Makefile linux-3.0.23-vs2.3.2.3/Makefile
--- linux-3.0.23/Makefile	2012-03-01 21:46:13.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/Makefile	2012-03-01 22:09:43.000000000 +0100
@@ -1,7 +1,7 @@
 VERSION = 3
 PATCHLEVEL = 0
 SUBLEVEL = 23
-EXTRAVERSION =
+EXTRAVERSION = -vs2.3.2.3
 NAME = Sneaky Weasel
 
 # *DOCUMENTATION*
diff -NurpP --minimal linux-3.0.23/arch/alpha/Kconfig linux-3.0.23-vs2.3.2.3/arch/alpha/Kconfig
--- linux-3.0.23/arch/alpha/Kconfig	2011-07-22 11:17:32.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/alpha/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -668,6 +668,8 @@ config DUMMY_CONSOLE
 	depends on VGA_HOSE
 	default y
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/alpha/kernel/entry.S linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/entry.S
--- linux-3.0.23/arch/alpha/kernel/entry.S	2010-10-21 13:06:45.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/entry.S	2011-06-10 22:11:24.000000000 +0200
@@ -860,24 +860,15 @@ sys_getxgid:
 	.globl	sys_getxpid
 	.ent	sys_getxpid
 sys_getxpid:
+	lda	$sp, -16($sp)
+	stq	$26, 0($sp)
 	.prologue 0
-	ldq	$2, TI_TASK($8)
 
-	/* See linux/kernel/timer.c sys_getppid for discussion
-	   about this loop.  */
-	ldq	$3, TASK_GROUP_LEADER($2)
-	ldq	$4, TASK_REAL_PARENT($3)
-	ldl	$0, TASK_TGID($2)
-1:	ldl	$1, TASK_TGID($4)
-#ifdef CONFIG_SMP
-	mov	$4, $5
-	mb
-	ldq	$3, TASK_GROUP_LEADER($2)
-	ldq	$4, TASK_REAL_PARENT($3)
-	cmpeq	$4, $5, $5
-	beq	$5, 1b
-#endif
-	stq	$1, 80($sp)
+	lda	$16, 96($sp)
+	jsr	$26, do_getxpid
+	ldq	$26, 0($sp)
+
+	lda	$sp, 16($sp)
 	ret
 .end sys_getxpid
 
diff -NurpP --minimal linux-3.0.23/arch/alpha/kernel/ptrace.c linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/ptrace.c
--- linux-3.0.23/arch/alpha/kernel/ptrace.c	2011-01-05 21:48:40.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/ptrace.c	2011-06-10 22:11:24.000000000 +0200
@@ -13,6 +13,7 @@
 #include <linux/user.h>
 #include <linux/security.h>
 #include <linux/signal.h>
+#include <linux/vs_base.h>
 
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
diff -NurpP --minimal linux-3.0.23/arch/alpha/kernel/systbls.S linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/systbls.S
--- linux-3.0.23/arch/alpha/kernel/systbls.S	2011-07-22 11:17:32.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/systbls.S	2011-06-10 22:11:24.000000000 +0200
@@ -446,7 +446,7 @@ sys_call_table:
 	.quad sys_stat64			/* 425 */
 	.quad sys_lstat64
 	.quad sys_fstat64
-	.quad sys_ni_syscall			/* sys_vserver */
+	.quad sys_vserver			/* sys_vserver */
 	.quad sys_ni_syscall			/* sys_mbind */
 	.quad sys_ni_syscall			/* sys_get_mempolicy */
 	.quad sys_ni_syscall			/* sys_set_mempolicy */
diff -NurpP --minimal linux-3.0.23/arch/alpha/kernel/traps.c linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/traps.c
--- linux-3.0.23/arch/alpha/kernel/traps.c	2010-10-21 13:06:46.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/alpha/kernel/traps.c	2011-06-10 22:11:24.000000000 +0200
@@ -183,7 +183,8 @@ die_if_kernel(char * str, struct pt_regs
 #ifdef CONFIG_SMP
 	printk("CPU %d ", hard_smp_processor_id());
 #endif
-	printk("%s(%d): %s %ld\n", current->comm, task_pid_nr(current), str, err);
+	printk("%s(%d[#%u]): %s %ld\n", current->comm,
+		task_pid_nr(current), current->xid, str, err);
 	dik_show_regs(regs, r9_15);
 	add_taint(TAINT_DIE);
 	dik_show_trace((unsigned long *)(regs+1));
diff -NurpP --minimal linux-3.0.23/arch/arm/Kconfig linux-3.0.23-vs2.3.2.3/arch/arm/Kconfig
--- linux-3.0.23/arch/arm/Kconfig	2012-03-01 21:46:13.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/arm/Kconfig	2011-12-19 15:55:53.000000000 +0100
@@ -2061,6 +2061,8 @@ source "fs/Kconfig"
 
 source "arch/arm/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/arm/kernel/calls.S linux-3.0.23-vs2.3.2.3/arch/arm/kernel/calls.S
--- linux-3.0.23/arch/arm/kernel/calls.S	2011-07-22 11:17:32.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/arm/kernel/calls.S	2011-06-10 22:11:24.000000000 +0200
@@ -322,7 +322,7 @@
 /* 310 */	CALL(sys_request_key)
 		CALL(sys_keyctl)
 		CALL(ABI(sys_semtimedop, sys_oabi_semtimedop))
-/* vserver */	CALL(sys_ni_syscall)
+		CALL(sys_vserver)
 		CALL(sys_ioprio_set)
 /* 315 */	CALL(sys_ioprio_get)
 		CALL(sys_inotify_init)
diff -NurpP --minimal linux-3.0.23/arch/arm/kernel/process.c linux-3.0.23-vs2.3.2.3/arch/arm/kernel/process.c
--- linux-3.0.23/arch/arm/kernel/process.c	2012-03-01 21:46:13.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/arm/kernel/process.c	2011-12-19 15:55:53.000000000 +0100
@@ -318,7 +318,8 @@ void __show_regs(struct pt_regs *regs)
 void show_regs(struct pt_regs * regs)
 {
 	printk("\n");
-	printk("Pid: %d, comm: %20s\n", task_pid_nr(current), current->comm);
+	printk("Pid: %d[#%u], comm: %20s\n",
+		task_pid_nr(current), current->xid, current->comm);
 	__show_regs(regs);
 	__backtrace();
 }
diff -NurpP --minimal linux-3.0.23/arch/arm/kernel/traps.c linux-3.0.23-vs2.3.2.3/arch/arm/kernel/traps.c
--- linux-3.0.23/arch/arm/kernel/traps.c	2011-07-22 11:17:32.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/arm/kernel/traps.c	2011-06-22 12:39:12.000000000 +0200
@@ -242,8 +242,8 @@ static int __die(const char *str, int er
 
 	print_modules();
 	__show_regs(regs);
-	printk(KERN_EMERG "Process %.*s (pid: %d, stack limit = 0x%p)\n",
-		TASK_COMM_LEN, tsk->comm, task_pid_nr(tsk), thread + 1);
+	printk(KERN_EMERG "Process %.*s (pid: %d:#%u, stack limit = 0x%p)\n",
+		TASK_COMM_LEN, tsk->comm, task_pid_nr(tsk), tsk->xid, thread + 1);
 
 	if (!user_mode(regs) || in_interrupt()) {
 		dump_mem(KERN_EMERG, "Stack: ", regs->ARM_sp,
diff -NurpP --minimal linux-3.0.23/arch/cris/Kconfig linux-3.0.23-vs2.3.2.3/arch/cris/Kconfig
--- linux-3.0.23/arch/cris/Kconfig	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/cris/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -678,6 +678,8 @@ source "drivers/staging/Kconfig"
 
 source "arch/cris/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/frv/kernel/kernel_thread.S linux-3.0.23-vs2.3.2.3/arch/frv/kernel/kernel_thread.S
--- linux-3.0.23/arch/frv/kernel/kernel_thread.S	2008-12-25 00:26:37.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/frv/kernel/kernel_thread.S	2011-06-10 22:11:24.000000000 +0200
@@ -37,7 +37,7 @@ kernel_thread:
 
 	# start by forking the current process, but with shared VM
 	setlos.p	#__NR_clone,gr7		; syscall number
-	ori		gr10,#CLONE_VM,gr8	; first syscall arg	[clone_flags]
+	ori		gr10,#CLONE_KT,gr8	; first syscall arg	[clone_flags]
 	sethi.p		#0xe4e4,gr9		; second syscall arg	[newsp]
 	setlo		#0xe4e4,gr9
 	setlos.p	#0,gr10			; third syscall arg	[parent_tidptr]
diff -NurpP --minimal linux-3.0.23/arch/h8300/Kconfig linux-3.0.23-vs2.3.2.3/arch/h8300/Kconfig
--- linux-3.0.23/arch/h8300/Kconfig	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/h8300/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -213,6 +213,8 @@ source "fs/Kconfig"
 
 source "arch/h8300/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/ia64/Kconfig linux-3.0.23-vs2.3.2.3/arch/ia64/Kconfig
--- linux-3.0.23/arch/ia64/Kconfig	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -671,6 +671,8 @@ source "fs/Kconfig"
 
 source "arch/ia64/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/ia64/include/asm/tlb.h linux-3.0.23-vs2.3.2.3/arch/ia64/include/asm/tlb.h
--- linux-3.0.23/arch/ia64/include/asm/tlb.h	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/include/asm/tlb.h	2011-06-10 22:11:24.000000000 +0200
@@ -40,6 +40,7 @@
 #include <linux/mm.h>
 #include <linux/pagemap.h>
 #include <linux/swap.h>
+#include <linux/vs_memory.h>
 
 #include <asm/pgalloc.h>
 #include <asm/processor.h>
diff -NurpP --minimal linux-3.0.23/arch/ia64/kernel/entry.S linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/entry.S
--- linux-3.0.23/arch/ia64/kernel/entry.S	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/entry.S	2011-06-10 22:11:24.000000000 +0200
@@ -1714,7 +1714,7 @@ sys_call_table:
 	data8 sys_mq_notify
 	data8 sys_mq_getsetattr
 	data8 sys_kexec_load
-	data8 sys_ni_syscall			// reserved for vserver
+	data8 sys_vserver
 	data8 sys_waitid			// 1270
 	data8 sys_add_key
 	data8 sys_request_key
diff -NurpP --minimal linux-3.0.23/arch/ia64/kernel/perfmon.c linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/perfmon.c
--- linux-3.0.23/arch/ia64/kernel/perfmon.c	2011-03-15 18:06:39.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/perfmon.c	2011-06-10 22:11:24.000000000 +0200
@@ -42,6 +42,7 @@
 #include <linux/completion.h>
 #include <linux/tracehook.h>
 #include <linux/slab.h>
+#include <linux/vs_memory.h>
 
 #include <asm/errno.h>
 #include <asm/intrinsics.h>
diff -NurpP --minimal linux-3.0.23/arch/ia64/kernel/process.c linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/process.c
--- linux-3.0.23/arch/ia64/kernel/process.c	2011-03-15 18:06:39.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/process.c	2011-06-10 22:11:24.000000000 +0200
@@ -109,8 +109,8 @@ show_regs (struct pt_regs *regs)
 	unsigned long ip = regs->cr_iip + ia64_psr(regs)->ri;
 
 	print_modules();
-	printk("\nPid: %d, CPU %d, comm: %20s\n", task_pid_nr(current),
-			smp_processor_id(), current->comm);
+	printk("\nPid: %d[#%u], CPU %d, comm: %20s\n", task_pid_nr(current),
+			current->xid, smp_processor_id(), current->comm);
 	printk("psr : %016lx ifs : %016lx ip  : [<%016lx>]    %s (%s)\n",
 	       regs->cr_ipsr, regs->cr_ifs, ip, print_tainted(),
 	       init_utsname()->release);
diff -NurpP --minimal linux-3.0.23/arch/ia64/kernel/ptrace.c linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/ptrace.c
--- linux-3.0.23/arch/ia64/kernel/ptrace.c	2011-01-05 21:48:59.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/ptrace.c	2011-06-10 22:11:24.000000000 +0200
@@ -21,6 +21,7 @@
 #include <linux/regset.h>
 #include <linux/elf.h>
 #include <linux/tracehook.h>
+#include <linux/vs_base.h>
 
 #include <asm/pgtable.h>
 #include <asm/processor.h>
diff -NurpP --minimal linux-3.0.23/arch/ia64/kernel/traps.c linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/traps.c
--- linux-3.0.23/arch/ia64/kernel/traps.c	2010-07-07 18:31:01.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/kernel/traps.c	2011-06-10 22:11:24.000000000 +0200
@@ -59,8 +59,9 @@ die (const char *str, struct pt_regs *re
 	put_cpu();
 
 	if (++die.lock_owner_depth < 3) {
-		printk("%s[%d]: %s %ld [%d]\n",
-		current->comm, task_pid_nr(current), str, err, ++die_counter);
+		printk("%s[%d[#%u]]: %s %ld [%d]\n",
+			current->comm, task_pid_nr(current), current->xid,
+			str, err, ++die_counter);
 		if (notify_die(DIE_OOPS, str, regs, err, 255, SIGSEGV)
 	            != NOTIFY_STOP)
 			show_regs(regs);
@@ -323,8 +324,9 @@ handle_fpu_swa (int fp_fault, struct pt_
 			if ((last.count & 15) < 5 && (ia64_fetchadd(1, &last.count, acq) & 15) < 5) {
 				last.time = current_jiffies + 5 * HZ;
 				printk(KERN_WARNING
-		       			"%s(%d): floating-point assist fault at ip %016lx, isr %016lx\n",
-		       			current->comm, task_pid_nr(current), regs->cr_iip + ia64_psr(regs)->ri, isr);
+					"%s(%d[#%u]): floating-point assist fault at ip %016lx, isr %016lx\n",
+					current->comm, task_pid_nr(current), current->xid,
+					regs->cr_iip + ia64_psr(regs)->ri, isr);
 			}
 		}
 	}
diff -NurpP --minimal linux-3.0.23/arch/ia64/mm/fault.c linux-3.0.23-vs2.3.2.3/arch/ia64/mm/fault.c
--- linux-3.0.23/arch/ia64/mm/fault.c	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/ia64/mm/fault.c	2011-06-10 22:28:23.000000000 +0200
@@ -11,6 +11,7 @@
 #include <linux/kprobes.h>
 #include <linux/kdebug.h>
 #include <linux/prefetch.h>
+#include <linux/vs_memory.h>
 
 #include <asm/pgtable.h>
 #include <asm/processor.h>
diff -NurpP --minimal linux-3.0.23/arch/m32r/kernel/traps.c linux-3.0.23-vs2.3.2.3/arch/m32r/kernel/traps.c
--- linux-3.0.23/arch/m32r/kernel/traps.c	2009-12-03 20:01:57.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/m32r/kernel/traps.c	2011-06-10 22:11:24.000000000 +0200
@@ -196,8 +196,9 @@ static void show_registers(struct pt_reg
 	} else {
 		printk("SPI: %08lx\n", sp);
 	}
-	printk("Process %s (pid: %d, process nr: %d, stackpage=%08lx)",
-		current->comm, task_pid_nr(current), 0xffff & i, 4096+(unsigned long)current);
+	printk("Process %s (pid: %d[#%u], process nr: %d, stackpage=%08lx)",
+		current->comm, task_pid_nr(current), current->xid,
+		0xffff & i, 4096+(unsigned long)current);
 
 	/*
 	 * When in-kernel, we also print out the stack and code at the
diff -NurpP --minimal linux-3.0.23/arch/m68k/Kconfig linux-3.0.23-vs2.3.2.3/arch/m68k/Kconfig
--- linux-3.0.23/arch/m68k/Kconfig	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/m68k/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -241,6 +241,8 @@ source "fs/Kconfig"
 
 source "arch/m68k/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/mips/Kconfig linux-3.0.23-vs2.3.2.3/arch/mips/Kconfig
--- linux-3.0.23/arch/mips/Kconfig	2011-07-22 11:17:35.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/mips/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -2485,6 +2485,8 @@ source "fs/Kconfig"
 
 source "arch/mips/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/mips/kernel/ptrace.c linux-3.0.23-vs2.3.2.3/arch/mips/kernel/ptrace.c
--- linux-3.0.23/arch/mips/kernel/ptrace.c	2011-07-22 11:17:36.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/mips/kernel/ptrace.c	2011-06-10 22:11:24.000000000 +0200
@@ -25,6 +25,7 @@
 #include <linux/security.h>
 #include <linux/audit.h>
 #include <linux/seccomp.h>
+#include <linux/vs_base.h>
 
 #include <asm/byteorder.h>
 #include <asm/cpu.h>
@@ -263,6 +264,9 @@ long arch_ptrace(struct task_struct *chi
 	void __user *datavp = (void __user *) data;
 	unsigned long __user *datalp = (void __user *) data;
 
+	if (!vx_check(vx_task_xid(child), VS_WATCH_P | VS_IDENT))
+		goto out;
+
 	switch (request) {
 	/* when I and D space are separate, these will need to be fixed. */
 	case PTRACE_PEEKTEXT: /* read word at location addr. */
diff -NurpP --minimal linux-3.0.23/arch/mips/kernel/scall32-o32.S linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall32-o32.S
--- linux-3.0.23/arch/mips/kernel/scall32-o32.S	2011-07-22 11:17:36.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall32-o32.S	2011-06-10 22:11:24.000000000 +0200
@@ -523,7 +523,7 @@ einval:	li	v0, -ENOSYS
 	sys	sys_mq_timedreceive	5
 	sys	sys_mq_notify		2	/* 4275 */
 	sys	sys_mq_getsetattr	3
-	sys	sys_ni_syscall		0	/* sys_vserver */
+	sys	sys_vserver		3
 	sys	sys_waitid		5
 	sys	sys_ni_syscall		0	/* available, was setaltroot */
 	sys	sys_add_key		5	/* 4280 */
diff -NurpP --minimal linux-3.0.23/arch/mips/kernel/scall64-64.S linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall64-64.S
--- linux-3.0.23/arch/mips/kernel/scall64-64.S	2011-07-22 11:17:36.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall64-64.S	2011-06-10 22:11:24.000000000 +0200
@@ -362,7 +362,7 @@ sys_call_table:
 	PTR	sys_mq_timedreceive
 	PTR	sys_mq_notify
 	PTR	sys_mq_getsetattr		/* 5235 */
-	PTR	sys_ni_syscall			/* sys_vserver */
+	PTR	sys_vserver
 	PTR	sys_waitid
 	PTR	sys_ni_syscall			/* available, was setaltroot */
 	PTR	sys_add_key
diff -NurpP --minimal linux-3.0.23/arch/mips/kernel/scall64-n32.S linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall64-n32.S
--- linux-3.0.23/arch/mips/kernel/scall64-n32.S	2011-07-22 11:17:36.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall64-n32.S	2011-06-10 22:11:24.000000000 +0200
@@ -361,7 +361,7 @@ EXPORT(sysn32_call_table)
 	PTR	compat_sys_mq_timedreceive
 	PTR	compat_sys_mq_notify
 	PTR	compat_sys_mq_getsetattr
-	PTR	sys_ni_syscall			/* 6240, sys_vserver */
+	PTR	sys32_vserver			/* 6240 */
 	PTR	compat_sys_waitid
 	PTR	sys_ni_syscall			/* available, was setaltroot */
 	PTR	sys_add_key
diff -NurpP --minimal linux-3.0.23/arch/mips/kernel/scall64-o32.S linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall64-o32.S
--- linux-3.0.23/arch/mips/kernel/scall64-o32.S	2011-07-22 11:17:36.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/mips/kernel/scall64-o32.S	2011-06-10 22:11:24.000000000 +0200
@@ -480,7 +480,7 @@ sys_call_table:
 	PTR	compat_sys_mq_timedreceive
 	PTR	compat_sys_mq_notify		/* 4275 */
 	PTR	compat_sys_mq_getsetattr
-	PTR	sys_ni_syscall			/* sys_vserver */
+	PTR	sys32_vserver
 	PTR	sys_32_waitid
 	PTR	sys_ni_syscall			/* available, was setaltroot */
 	PTR	sys_add_key			/* 4280 */
diff -NurpP --minimal linux-3.0.23/arch/mips/kernel/traps.c linux-3.0.23-vs2.3.2.3/arch/mips/kernel/traps.c
--- linux-3.0.23/arch/mips/kernel/traps.c	2011-05-22 16:17:00.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/mips/kernel/traps.c	2011-06-10 22:11:24.000000000 +0200
@@ -343,9 +343,10 @@ void show_registers(struct pt_regs *regs
 
 	__show_regs(regs);
 	print_modules();
-	printk("Process %s (pid: %d, threadinfo=%p, task=%p, tls=%0*lx)\n",
-	       current->comm, current->pid, current_thread_info(), current,
-	      field, current_thread_info()->tp_value);
+	printk("Process %s (pid: %d:#%u, threadinfo=%p, task=%p, tls=%0*lx)\n",
+		current->comm, task_pid_nr(current), current->xid,
+		current_thread_info(), current,
+		field, current_thread_info()->tp_value);
 	if (cpu_has_userlocal) {
 		unsigned long tls;
 
diff -NurpP --minimal linux-3.0.23/arch/parisc/Kconfig linux-3.0.23-vs2.3.2.3/arch/parisc/Kconfig
--- linux-3.0.23/arch/parisc/Kconfig	2011-07-22 11:17:36.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/parisc/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -279,6 +279,8 @@ source "fs/Kconfig"
 
 source "arch/parisc/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/parisc/kernel/syscall_table.S linux-3.0.23-vs2.3.2.3/arch/parisc/kernel/syscall_table.S
--- linux-3.0.23/arch/parisc/kernel/syscall_table.S	2012-03-01 21:46:14.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/parisc/kernel/syscall_table.S	2011-08-29 03:45:07.000000000 +0200
@@ -361,7 +361,7 @@
 	ENTRY_COMP(mbind)		/* 260 */
 	ENTRY_COMP(get_mempolicy)
 	ENTRY_COMP(set_mempolicy)
-	ENTRY_SAME(ni_syscall)	/* 263: reserved for vserver */
+	ENTRY_DIFF(vserver)
 	ENTRY_SAME(add_key)
 	ENTRY_SAME(request_key)		/* 265 */
 	ENTRY_SAME(keyctl)
diff -NurpP --minimal linux-3.0.23/arch/parisc/kernel/traps.c linux-3.0.23-vs2.3.2.3/arch/parisc/kernel/traps.c
--- linux-3.0.23/arch/parisc/kernel/traps.c	2009-09-10 15:25:40.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/parisc/kernel/traps.c	2011-06-10 22:11:24.000000000 +0200
@@ -236,8 +236,9 @@ void die_if_kernel(char *str, struct pt_
 		if (err == 0)
 			return; /* STFU */
 
-		printk(KERN_CRIT "%s (pid %d): %s (code %ld) at " RFMT "\n",
-			current->comm, task_pid_nr(current), str, err, regs->iaoq[0]);
+		printk(KERN_CRIT "%s (pid %d:#%u): %s (code %ld) at " RFMT "\n",
+			current->comm, task_pid_nr(current), current->xid,
+			str, err, regs->iaoq[0]);
 #ifdef PRINT_USER_FAULTS
 		/* XXX for debugging only */
 		show_regs(regs);
@@ -270,8 +271,8 @@ void die_if_kernel(char *str, struct pt_
 		pdc_console_restart();
 	
 	if (err)
-		printk(KERN_CRIT "%s (pid %d): %s (code %ld)\n",
-			current->comm, task_pid_nr(current), str, err);
+		printk(KERN_CRIT "%s (pid %d:#%u): %s (code %ld)\n",
+			current->comm, task_pid_nr(current), current->xid, str, err);
 
 	/* Wot's wrong wif bein' racy? */
 	if (current->thread.flags & PARISC_KERNEL_DEATH) {
diff -NurpP --minimal linux-3.0.23/arch/parisc/mm/fault.c linux-3.0.23-vs2.3.2.3/arch/parisc/mm/fault.c
--- linux-3.0.23/arch/parisc/mm/fault.c	2010-08-02 16:52:06.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/parisc/mm/fault.c	2011-06-10 22:11:24.000000000 +0200
@@ -237,8 +237,9 @@ bad_area:
 
 #ifdef PRINT_USER_FAULTS
 		printk(KERN_DEBUG "\n");
-		printk(KERN_DEBUG "do_page_fault() pid=%d command='%s' type=%lu address=0x%08lx\n",
-		    task_pid_nr(tsk), tsk->comm, code, address);
+		printk(KERN_DEBUG "do_page_fault() pid=%d:#%u "
+		    "command='%s' type=%lu address=0x%08lx\n",
+		    task_pid_nr(tsk), tsk->xid, tsk->comm, code, address);
 		if (vma) {
 			printk(KERN_DEBUG "vm_start = 0x%08lx, vm_end = 0x%08lx\n",
 					vma->vm_start, vma->vm_end);
diff -NurpP --minimal linux-3.0.23/arch/powerpc/Kconfig linux-3.0.23-vs2.3.2.3/arch/powerpc/Kconfig
--- linux-3.0.23/arch/powerpc/Kconfig	2011-07-22 11:17:36.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/powerpc/Kconfig	2011-06-10 22:11:24.000000000 +0200
@@ -978,6 +978,8 @@ source "lib/Kconfig"
 
 source "arch/powerpc/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 config KEYS_COMPAT
diff -NurpP --minimal linux-3.0.23/arch/powerpc/include/asm/unistd.h linux-3.0.23-vs2.3.2.3/arch/powerpc/include/asm/unistd.h
--- linux-3.0.23/arch/powerpc/include/asm/unistd.h	2011-07-22 11:17:40.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/powerpc/include/asm/unistd.h	2011-06-10 22:11:24.000000000 +0200
@@ -275,7 +275,7 @@
 #endif
 #define __NR_rtas		255
 #define __NR_sys_debug_setcontext 256
-/* Number 257 is reserved for vserver */
+#define __NR_vserver		257
 #define __NR_migrate_pages	258
 #define __NR_mbind		259
 #define __NR_get_mempolicy	260
diff -NurpP --minimal linux-3.0.23/arch/powerpc/kernel/process.c linux-3.0.23-vs2.3.2.3/arch/powerpc/kernel/process.c
--- linux-3.0.23/arch/powerpc/kernel/process.c	2011-07-22 11:17:40.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/powerpc/kernel/process.c	2011-06-10 22:11:24.000000000 +0200
@@ -656,8 +656,9 @@ void show_regs(struct pt_regs * regs)
 #else
 		printk("DAR: "REG", DSISR: %08lx\n", regs->dar, regs->dsisr);
 #endif
-	printk("TASK = %p[%d] '%s' THREAD: %p",
-	       current, task_pid_nr(current), current->comm, task_thread_info(current));
+	printk("TASK = %p[%d,#%u] '%s' THREAD: %p",
+	       current, task_pid_nr(current), current->xid,
+	       current->comm, task_thread_info(current));
 
 #ifdef CONFIG_SMP
 	printk(" CPU: %d", raw_smp_processor_id());
diff -NurpP --minimal linux-3.0.23/arch/powerpc/kernel/traps.c linux-3.0.23-vs2.3.2.3/arch/powerpc/kernel/traps.c
--- linux-3.0.23/arch/powerpc/kernel/traps.c	2011-07-22 11:17:40.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/powerpc/kernel/traps.c	2011-07-19 00:44:39.000000000 +0200
@@ -1075,8 +1075,9 @@ void nonrecoverable_exception(struct pt_
 
 void trace_syscall(struct pt_regs *regs)
 {
-	printk("Task: %p(%d), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
-	       current, task_pid_nr(current), regs->nip, regs->link, regs->gpr[0],
+	printk("Task: %p(%d[#%u]), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
+	       current, task_pid_nr(current), current->xid,
+	       regs->nip, regs->link, regs->gpr[0],
 	       regs->ccr&0x10000000?"Error=":"", regs->gpr[3], print_tainted());
 }
 
diff -NurpP --minimal linux-3.0.23/arch/powerpc/kernel/vdso.c linux-3.0.23-vs2.3.2.3/arch/powerpc/kernel/vdso.c
--- linux-3.0.23/arch/powerpc/kernel/vdso.c	2011-05-22 16:17:02.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/powerpc/kernel/vdso.c	2011-06-10 22:11:24.000000000 +0200
@@ -23,6 +23,7 @@
 #include <linux/security.h>
 #include <linux/bootmem.h>
 #include <linux/memblock.h>
+#include <linux/vs_memory.h>
 
 #include <asm/pgtable.h>
 #include <asm/system.h>
diff -NurpP --minimal linux-3.0.23/arch/s390/Kconfig linux-3.0.23-vs2.3.2.3/arch/s390/Kconfig
--- linux-3.0.23/arch/s390/Kconfig	2011-07-22 11:17:41.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/s390/Kconfig	2011-07-01 11:35:34.000000000 +0200
@@ -628,6 +628,8 @@ source "fs/Kconfig"
 
 source "arch/s390/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/s390/include/asm/tlb.h linux-3.0.23-vs2.3.2.3/arch/s390/include/asm/tlb.h
--- linux-3.0.23/arch/s390/include/asm/tlb.h	2011-07-22 11:17:41.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/s390/include/asm/tlb.h	2011-06-15 02:40:14.000000000 +0200
@@ -24,6 +24,8 @@
 #include <linux/mm.h>
 #include <linux/pagemap.h>
 #include <linux/swap.h>
+#include <linux/vs_memory.h>
+
 #include <asm/processor.h>
 #include <asm/pgalloc.h>
 #include <asm/tlbflush.h>
diff -NurpP --minimal linux-3.0.23/arch/s390/include/asm/unistd.h linux-3.0.23-vs2.3.2.3/arch/s390/include/asm/unistd.h
--- linux-3.0.23/arch/s390/include/asm/unistd.h	2011-07-22 11:17:41.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/s390/include/asm/unistd.h	2011-06-10 22:11:24.000000000 +0200
@@ -202,7 +202,7 @@
 #define __NR_clock_gettime	(__NR_timer_create+6)
 #define __NR_clock_getres	(__NR_timer_create+7)
 #define __NR_clock_nanosleep	(__NR_timer_create+8)
-/* Number 263 is reserved for vserver */
+#define __NR_vserver		263
 #define __NR_statfs64		265
 #define __NR_fstatfs64		266
 #define __NR_remap_file_pages	267
diff -NurpP --minimal linux-3.0.23/arch/s390/kernel/ptrace.c linux-3.0.23-vs2.3.2.3/arch/s390/kernel/ptrace.c
--- linux-3.0.23/arch/s390/kernel/ptrace.c	2012-03-01 21:46:14.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/s390/kernel/ptrace.c	2011-12-19 15:55:53.000000000 +0100
@@ -20,6 +20,7 @@
 #include <linux/regset.h>
 #include <linux/tracehook.h>
 #include <linux/seccomp.h>
+#include <linux/vs_base.h>
 #include <trace/syscall.h>
 #include <asm/compat.h>
 #include <asm/segment.h>
diff -NurpP --minimal linux-3.0.23/arch/s390/kernel/syscalls.S linux-3.0.23-vs2.3.2.3/arch/s390/kernel/syscalls.S
--- linux-3.0.23/arch/s390/kernel/syscalls.S	2011-07-22 11:17:41.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/s390/kernel/syscalls.S	2011-06-10 22:11:24.000000000 +0200
@@ -271,7 +271,7 @@ SYSCALL(sys_clock_settime,sys_clock_sett
 SYSCALL(sys_clock_gettime,sys_clock_gettime,sys32_clock_gettime_wrapper)	/* 260 */
 SYSCALL(sys_clock_getres,sys_clock_getres,sys32_clock_getres_wrapper)
 SYSCALL(sys_clock_nanosleep,sys_clock_nanosleep,sys32_clock_nanosleep_wrapper)
-NI_SYSCALL							/* reserved for vserver */
+SYSCALL(sys_vserver,sys_vserver,sys32_vserver)
 SYSCALL(sys_s390_fadvise64_64,sys_ni_syscall,sys32_fadvise64_64_wrapper)
 SYSCALL(sys_statfs64,sys_statfs64,compat_sys_statfs64_wrapper)
 SYSCALL(sys_fstatfs64,sys_fstatfs64,compat_sys_fstatfs64_wrapper)
diff -NurpP --minimal linux-3.0.23/arch/sh/Kconfig linux-3.0.23-vs2.3.2.3/arch/sh/Kconfig
--- linux-3.0.23/arch/sh/Kconfig	2011-07-22 11:17:41.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/sh/Kconfig	2011-07-19 00:44:39.000000000 +0200
@@ -893,6 +893,8 @@ source "fs/Kconfig"
 
 source "arch/sh/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/sh/kernel/irq.c linux-3.0.23-vs2.3.2.3/arch/sh/kernel/irq.c
--- linux-3.0.23/arch/sh/kernel/irq.c	2011-07-22 11:17:41.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/sh/kernel/irq.c	2011-07-19 00:45:06.000000000 +0200
@@ -14,6 +14,7 @@
 #include <linux/ftrace.h>
 #include <linux/delay.h>
 #include <linux/ratelimit.h>
+// #include <linux/vs_context.h>
 #include <asm/processor.h>
 #include <asm/machvec.h>
 #include <asm/uaccess.h>
diff -NurpP --minimal linux-3.0.23/arch/sh/kernel/vsyscall/vsyscall.c linux-3.0.23-vs2.3.2.3/arch/sh/kernel/vsyscall/vsyscall.c
--- linux-3.0.23/arch/sh/kernel/vsyscall/vsyscall.c	2011-05-22 16:17:07.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/sh/kernel/vsyscall/vsyscall.c	2011-06-10 22:11:24.000000000 +0200
@@ -18,6 +18,7 @@
 #include <linux/elf.h>
 #include <linux/sched.h>
 #include <linux/err.h>
+#include <linux/vs_memory.h>
 
 /*
  * Should the kernel map a VDSO page into processes and pass its
diff -NurpP --minimal linux-3.0.23/arch/sparc/Kconfig linux-3.0.23-vs2.3.2.3/arch/sparc/Kconfig
--- linux-3.0.23/arch/sparc/Kconfig	2012-03-01 21:46:14.000000000 +0100
+++ linux-3.0.23-vs2.3.2.3/arch/sparc/Kconfig	2011-10-18 13:51:13.000000000 +0200
@@ -602,6 +602,8 @@ source "fs/Kconfig"
 
 source "arch/sparc/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-3.0.23/arch/sparc/include/asm/tlb_64.h linux-3.0.23-vs2.3.2.3/arch/sparc/include/asm/tlb_64.h
--- linux-3.0.23/arch/sparc/include/asm/tlb_64.h	2011-07-22 11:17:42.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/sparc/include/asm/tlb_64.h	2011-06-10 22:11:24.000000000 +0200
@@ -3,6 +3,7 @@
 
 #include <linux/swap.h>
 #include <linux/pagemap.h>
+#include <linux/vs_memory.h>
 #include <asm/pgalloc.h>
 #include <asm/tlbflush.h>
 #include <asm/mmu_context.h>
diff -NurpP --minimal linux-3.0.23/arch/sparc/include/asm/unistd.h linux-3.0.23-vs2.3.2.3/arch/sparc/include/asm/unistd.h
--- linux-3.0.23/arch/sparc/include/asm/unistd.h	2011-07-22 11:17:42.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/sparc/include/asm/unistd.h	2011-06-10 22:11:24.000000000 +0200
@@ -335,7 +335,7 @@
 #define __NR_timer_getoverrun	264
 #define __NR_timer_delete	265
 #define __NR_timer_create	266
-/* #define __NR_vserver		267 Reserved for VSERVER */
+#define __NR_vserver		267
 #define __NR_io_setup		268
 #define __NR_io_destroy		269
 #define __NR_io_submit		270
diff -NurpP --minimal linux-3.0.23/arch/sparc/kernel/systbls_32.S linux-3.0.23-vs2.3.2.3/arch/sparc/kernel/systbls_32.S
--- linux-3.0.23/arch/sparc/kernel/systbls_32.S	2011-07-22 11:17:42.000000000 +0200
+++ linux-3.0.23-vs2.3.2.3/arch/sparc/kernel/systbls_32.S	2011-06-10 22:11:24.000000000 +0200
@@ -70,7 +70,7 @@ sys_call_table:
 /*250*/	.long sys_mremap, sys_sysctl, sys_getsid, sys_fdatasync, sys_nfsservctl
 /*255*/	.long sys_sync_file_range, sys_clock_settime, sys_clock_gettime, sys_clock_getres, sys_clock_nanosleep
 /*260*/	.long sys_sched_getaffinity, sys_sched_setaffinity, sys_timer_settime, sys_timer_gettime, sys_timer_getoverrun
-/*265*/	.long sys_timer_delete, sys_timer_create, sys_nis_syscall, sys_io_setup, sys_io_destroy
+/*265*/	.long sys_timer_delete, sys_timer_create, sys_vserver, sys_io_setup, sys_io_destroy
 /*270*/	.long sys_io_submit, sys_io_cancel, sys_io_getevents, sys_mq_open, sys_mq_unlink
 /*275*/	.long sys_mq_timedsend, sys_mq_timedreceive, sys_mq_notify, sys_mq_getsetattr, sys_waitid
 /*280*/	.long sys_tee, sys_add_key, sys_request_key, sys_keyctl, sys_openat
